using namespace std;

class expr_exception
{
 public:
   expr_exception() : str_("unnamed exception") {;}
   expr_exception(const char *what_arg) : str_(what_arg) {;}
   expr_exception(const expr_exception &e) : str_(e . str_) {;}
   expr_exception & operator = (const expr_exception &e) { if (&e != this) str_ = e . str_; return *this; }
   virtual ~expr_exception() {;}
   virtual const char *what() const { return str_.data(); }
 private:
   string str_;
};

// t_value needs to support
//    . all unary, binary, and ternary operators
typedef int t_value;

void eval_expression(const string &expr, t_value &result, t_value (*get_variable)(const char *name));

